#include <windows.h>
#include <stdio.h>
#include "win075.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 075",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           544,                 /* Ancho */
           375,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static HFONT hfont;
    static HBRUSH pincel;
    HWND hctrl;
    SCROLLINFO si;
    char cad[128];

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           hfont = (HFONT)GetStockObject( DEFAULT_GUI_FONT );
           pincel = CreateSolidBrush(RGB(0,255,0));
           /* Insertar control */
           hctrl = CreateWindowEx(
              0,
              "SCROLLBAR",     /* Nombre de la clase */
              NULL,           /* Texto del ttulo */
              SBS_VERT | SBS_TOPALIGN | //SBS_SIZEBOX | SBS_SIZEBOXBOTTOMRIGHTALIGN |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              5, 5,            /* Posicin */
              28, 180,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_SCR1,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           si.cbSize = sizeof(si);
           si.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS;
           si.nMin   = 0;
           si.nMax   = 100;
           si.nPage  = 10;
           si.nPos   = 50;
           SetScrollInfo(hctrl, SB_CTL, &si, TRUE);
           hctrl = CreateWindowEx(
              0,
              "SCROLLBAR",     /* Nombre de la clase */
              NULL,           /* Texto del ttulo */
              SBS_HORZ | SBS_RIGHTALIGN |
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, /* Estilo */
              25, 185,            /* Posicin */
              180, 28,          /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_SCR2,/* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           si.cbSize = sizeof(si);
           si.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS;
           si.nMin   = -140;
           si.nMax   = 140;
           si.nPage  = 10;
           si.nPos   = 50;
           SetScrollInfo(hctrl, SB_CTL, &si, TRUE);
           SetFocus(hctrl);
           hctrl = CreateWindowEx(0,"BUTTON", "Ocultar",
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, 25, 5, 120, 25,
              hwnd, (HMENU)CM_OCULTAR, hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(0,"BUTTON", "Mostrar",
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, 25, 40, 120, 25,
              hwnd, (HMENU)CM_MOSTRAR, hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(0,"BUTTON", "Habilitar",
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, 150, 5, 120, 25,
              hwnd, (HMENU)CM_HABILITAR, hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(0,"BUTTON", "Deshabilitar",
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, 150, 40, 120, 25,
              hwnd, (HMENU)CM_DESHABILITAR, hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(0,"BUTTON", "Flecha arriba",
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, 275, 5, 120, 25,
              hwnd, (HMENU)CM_ARRIBA, hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(0,"BUTTON", "Flecha abajo",
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, 275, 40, 120, 25,
              hwnd, (HMENU)CM_ABAJO, hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(0,"BUTTON", "Ambas flechas",
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, 275, 75, 120, 25,
              hwnd, (HMENU)CM_AMBAS, hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(0,"BUTTON", "Habilitar",
              WS_CHILD | WS_VISIBLE | WS_TABSTOP, 275, 110, 120, 25,
              hwnd, (HMENU)CM_HABILFLECHAS, hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(0,"STATIC", "50",
              SS_CENTER | WS_BORDER | WS_CHILD | WS_VISIBLE, 25, 75, 120, 25,
              hwnd, (HMENU)ID_ESTATICO1, hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           hctrl = CreateWindowEx(0,"STATIC", "50",
              SS_CENTER | WS_BORDER | WS_CHILD | WS_VISIBLE, 25, 110, 120, 25,
              hwnd, (HMENU)ID_ESTATICO2, hInstance, NULL);
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           return 0;
        case WM_CTLCOLORSCROLLBAR:
           SetBkColor((HDC)wParam, RGB(0,255,0));
           return (LRESULT)pincel;
        case WM_HSCROLL:
           si.cbSize = sizeof(si);
           si.fMask  = SIF_ALL;
           GetScrollInfo((HWND)lParam, SB_CTL, &si);
           sprintf(cad, "%d", si.nPos);
           SetWindowText(GetDlgItem(hwnd, ID_ESTATICO2), cad);
           switch(LOWORD(wParam)) {
              case SB_LINERIGHT: si.nPos++; break;
              case SB_LINELEFT:  si.nPos--; break;
              case SB_PAGERIGHT: si.nPos += si.nPage; break;
              case SB_PAGELEFT:  si.nPos -= si.nPage; break;
              case SB_BOTTOM:    si.nPos = si.nMax; break;
              case SB_TOP:       si.nPos = si.nMin; break;
              //case SB_THUMBTRACK:
              case SB_THUMBPOSITION:
                   si.nPos = (int)wParam>>16; break;
           }
           si.cbSize = sizeof(si);
           si.fMask  = SIF_POS;
           SetScrollInfo((HWND)lParam, SB_CTL, &si, TRUE);
           RedrawWindow(hwnd, NULL, NULL, RDW_UPDATENOW | RDW_ALLCHILDREN);
           break;
        case WM_VSCROLL:
           si.cbSize = sizeof(si);
           si.fMask  = SIF_ALL;
           GetScrollInfo((HWND)lParam, SB_CTL, &si);
           sprintf(cad, "%d", si.nPos);
           SetWindowText(GetDlgItem(hwnd, ID_ESTATICO1), cad);
           switch(LOWORD(wParam)) {
              case SB_LINEDOWN: si.nPos++; break;
              case SB_LINEUP:   si.nPos--; break;
              case SB_PAGEDOWN: si.nPos += si.nPage; break;
              case SB_PAGEUP:   si.nPos -= si.nPage; break;
              case SB_BOTTOM:   si.nPos = si.nMax; break;
              case SB_TOP:      si.nPos = si.nMin; break;
              case SB_THUMBTRACK:
              //case SB_THUMBPOSITION:
                   si.nPos = (int)wParam>>16; break;
           }
           si.cbSize = sizeof(si);
           si.fMask  = SIF_POS;
           SetScrollInfo((HWND)lParam, SB_CTL, &si, TRUE);
           RedrawWindow(hwnd, NULL, NULL, RDW_UPDATENOW | RDW_ALLCHILDREN);
           break;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case CM_SALIR:
                DestroyWindow(hwnd);
                break;
              case CM_OCULTAR:
                ShowScrollBar(GetDlgItem(hwnd, ID_SCR1), SB_CTL, FALSE);
                break;
              case CM_MOSTRAR:
                ShowScrollBar(GetDlgItem(hwnd, ID_SCR1), SB_CTL, TRUE);
                break;
              case CM_HABILITAR:
                EnableWindow(GetDlgItem(hwnd, ID_SCR1), TRUE);
                break;
              case CM_DESHABILITAR:
                EnableWindow(GetDlgItem(hwnd, ID_SCR1), FALSE);
                break;
              case CM_ARRIBA:
                EnableScrollBar(GetDlgItem(hwnd, ID_SCR1), SB_CTL, ESB_DISABLE_UP);
                break;
              case CM_ABAJO:
                EnableScrollBar(GetDlgItem(hwnd, ID_SCR1), SB_CTL, ESB_DISABLE_DOWN);
                break;
              case CM_AMBAS:
                EnableScrollBar(GetDlgItem(hwnd, ID_SCR1), SB_CTL, ESB_DISABLE_BOTH);
                break;
              case CM_HABILFLECHAS:
                EnableScrollBar(GetDlgItem(hwnd, ID_SCR1), SB_CTL, ESB_ENABLE_BOTH);
                break;
           }
           break;
        case WM_DESTROY:
           DeleteObject(hfont);
           DeleteObject(pincel);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
